/*
 * =====================================================================================
 *
 *       Filename:  questions.cpp
 *
 *    Description:  Questions Class
 *
 *        Version:  1.0
 *        Created:  06/05/2011 07:08:05 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ruben Safir (), ruben@mrbrklyn.com
 *        Company:  NYLXS
 *
 * =====================================================================================
 */

#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
#include <iostream>
#include <iomanip>
#include <termios.h>
#include "questions.h"

namespace Questions{

   Question Deck::create_question(std::ostream &os , std::istream &in ){
      struct termios stored_settings;
      struct termios new_settings;
      std::string input_q, input_a;
      char keystroke;


      os << "Please Enter your question below \n Enter <esc> when finished" << std::endl;
      os << "==================================================================" << std::endl;

      tcgetattr(0,&stored_settings);

      new_settings = stored_settings;

      /* Disable canonical mode, and set buffer size to 1 byte */
      new_settings.c_lflag &= (~ICANON);
      new_settings.c_cc[VTIME] = 0;
      new_settings.c_cc[VMIN] = 1;

      tcsetattr(0,TCSANOW,&new_settings);

      while( (keystroke = getchar()) ){
	 if (keystroke == 27)
	    break;
	 input_q += keystroke;
      }
      os << "Please Enter your answer below \n Enter <esc> when finished" << std::endl;
      os << "==================================================================" << std::endl;

      while( (keystroke = getchar()) ){
	 if (keystroke == 27)
	    break;
	 input_a += keystroke;
      }

      Question quest(input_q, input_a);

      tcsetattr(0,TCSANOW,&stored_settings);
      return quest;
   } //end of create_question


   void menu(std::ostream &os){
      os << "Welcome the the C++ Quiz" << "\n\n\n\n" << std::endl;
      std::string tmp = " \n "
	 "Select from one of the following: \n\n"
	 "a) Insert Question and Answer into the database\n"
	 "b) Read 25 Questions and run Quiz\n\n\nResponse==> ";

      os << tmp << std::endl;

   }


   void selection(Deck &stack, std::istream &is = std::cin) {
      char choice;
      Question tmp;
      if(is >> choice){

	 switch ( choice ) {
	    case 'a':
	       tmp = stack.create_question();
	       stack.add_questions(tmp);
	       break;

	    case 'b':	
	       break;

	    default:	
	       break;
	 }				/* -----  end switch  ----- */
      }
   } //End of Questions::selection();

}         /* End of Namespace Questions */
