#ifndef QUESTION
#define QUESTION

#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
#include <iostream>
#include <iomanip>
#include <termios.h>

namespace Questions{

   class Question{

      public:
	 Question(std::string q, std::string a): quest(q), answer(a){ }
	 Question(){ }
	 Question(Question const &copy){
		 this->quest = copy.quest;
		 this->response = copy.response;
		 this->answer = copy.answer;
	 }
	 std::string quest;
	 std::string response;
	 std::string answer;







      private:



   }; //end Questions Class

   class Deck{

      public:
	 std::vector<Question> deck;
	 Deck(){
	    std::string home = std::getenv("HOME");
	    database = home + "/quiz.db";
	    size = 0;
	 }



	 void get_stack();
	 Question get_question();
	 void give_quiz();
	 void add_questions(Question &enter);
	 void add_database();
    	 Question create_question(std::ostream &os = std::cout, std::istream &in = std::cin );

      private:
	 int size;
	 std::string database;

   }; //end of Deck object Questions::Deck


   void menu(std::ostream &os = std::cout);
   void selection(Deck, std::istream &in = std::cin);


} //end of namespace Question


#endif


